# ifndef __filename_h
  # define __filename_h


/***************************************************************************************************************************
 
    FILE NAME :
      FILENAME.C


    DESCRIPTION :
      This header contains some declarations for some specific C functions for handling file names.  Nearly every operating
      system or C compiler provides a similiar set of functions.  The purpose of this module is to provide a PORTABLE set of
      such functions.
 

    Copyright 1997, Peter Garner
    This code may be used for any NON-MILITARY purpose.

***************************************************************************************************************************/


# ifdef __cplusplus
  extern "C"
  {
# endif  /* # ifndef __cplusplus  */


char        * makeFullFileName ( char * szFullName , const char * cszPath , const char * cszFileName ) ;
const char  * replaceExtension ( char * szFilePath , const char * cszNewExt ) ;



# ifdef __cplusplus
  }
# endif  /* # ifdef __cplusplus  */




# endif  /*  # ifndef __filename_h  */
