# ifndef __showexp_hpp
  # define __showexp_hpp

/***************************************************************************************************************************
 
    FILE NAME :
      SHOWEXP.HPP
 
 
    APPLICATION :
      GENERAL OPERATORS FOR OUTPUT OF IEXCEPTIONS ONTO ISTRING AND OSTREAMS
   
 
    DESCRIPTION :
      This header contains the declarations for the overloaded  '<<' operators to print IException and IExceptionLocation
      objects onto IStrings and ostreams.
 
***************************************************************************************************************************/


//  System Defined C++ Headers
# include <iostream.h>


//  IBM OCL Defined C++ Headers
# include <iexcept.hpp>



IString & operator << ( IString & ristr   , const IException          & rciexp    ) ;
IString & operator << ( IString & ristr   , const IExceptionLocation  & rciexploc ) ;

ostream & operator << ( ostream & rostrm  , const IException          & rciexp    ) ;
ostream & operator << ( ostream & rostrm  , const IExceptionLocation  & rciexploc ) ;



# endif  /*  # ifndef __showexp_hpp  */
