# ifndef __dbaseobj_hpp
  # define __dbaseobj_hpp

/***************************************************************************************************************************
 
    FILE NAME :
      DBASEOBJ.HPP
 
 
    DESCRIPTION :
      This header contains the declarations for the class DatabaseObject, a super class for our Database objects.  The
      primary purpose of this class is to serialize access to a Database.
 
 
    Copyright 1997, Peter Garner
    This code may be used for any NON-MILITARY purpose.
 
***************************************************************************************************************************/




//  IPrivateResource does not work under all versions of AIX, this is  our substitute
//  This conditional will get us by until it becomes available under AIX!
#ifdef _AIX
#include "creslock.hpp"
#else
#include <ireslock.hpp>
#endif	// _AIX


#include <namedobj.hpp>


class DatabaseObject : public NamedObject
{
public    :
//  Virtual Constant Methods
  virtual const char    * className           ()  const ;

protected :
  static IPrivateResource   & getDBResource   () ;

private   :
  static IPrivateResource     iprivresDB ;

} ; /* class DatabaseObject : public NamedObject */




# endif  /*  # ifndef __dbaseobj_hpp  */
