/***************************************************************************************************************************
 
    FILE NAME   :
      OS2PORT.C


    AUTHOR      :
      PETER GARNER
 
 
    APPLICATION :
      GENERAL

      
    DESCRIPTION :
      This module implements some common UNIX functions under OS/2 to ease in porting applications between UNIX and OS/2.

 
    METHODS DEFINED IN THIS MODULE :
      int     sleep   ( int nSeconds )

***************************************************************************************************************************/
/*  System Defined C Headers    */
# define  INCL_DOSPROCESS
# include <os2.h>


/*  Locally Defined C Headers    */
# include <os2port.h>



int sleep ( int nSeconds )
{
  /*  Convert to milliseconds for OS/2 DosSleep         */
  unsigned long   ulMilliSeconds  = nSeconds * 1000 ;

  /*  Call the OS/2 DosSleep with milliseconds          */
  DosSleep ( ulMilliSeconds ) ;

  /*  Return the value in seconds like UNIX does!       */
  return  nSeconds ;

} /* int sleep ( int nSeconds ) */




/*************************************************************************************************************************** 
****************************************************  PVCS INFORMATION  ****************************************************
****************************************************************************************************************************
  $Archive: $
   
  $Author:   PGARNER  $
   
  $Date: $
   
  $Revision: $
   
  $Workfile: $
   
  $Log: $
   
****************************************************************************************************************************
****************************************************  PVCS INFORMATION  ****************************************************
***************************************************************************************************************************/



/*********************************************   END OF FILE OS2PORT.C      ***********************************************/

