/***************************************************************************************************************************
 
    FILE NAME :
      KEYITEMTEST.CPP
 
 
    DESCRIPTION :
      This module test the OCL Collection Classes.


 
    METHODS DEFINED IN THIS MODULE :
      int   main  ( int nArgC , char ** ppcArgV )

 
    Copyright 1997, Peter Garner
    This code may be used for any NON-MILITARY purpose.


***************************************************************************************************************************/

# include <keyeditem.hpp>


typedef KeyedItem < int > IntKeyedItem  ;



class IntKeyedString : public IntKeyedItem
{
public    :
//  Constructors
  IntKeyedString ( int nKeyNew , const char * cszNew ) ;

//  Destructor
  ~IntKeyedString ()

//  Virtual Constant Methods
  virtual int const         & key ()  const ;

private   :
  int       nKey    ;
  IString   istring ;

} ; /* class IntKeyedString : public IntKeyedItem */



class CountedKeyedString : public IntKeyedString
{
public    :
//  Constructors
  CountedKeyedString () ;

private   :
  static int nObjCount  ; 

} ; /* class CountedKeyedString : public IntKeyedString */



int main ( int nArgC , char ** ppcArgV ) 
{
  IntKeyedString nkeyedstring ( 1 , IString (

  return  0 ;

} /* int main ( int nArgC , char ** ppcArgV ) */



CountedKeyedString :: CountedKeyedString ()
  : IntKeyedString ( nObjCount , "This is a CountedKeyString" )
{
 nObjCount++ ;

} /* CountedKeyedString :: CountedKeyedString () */



IntKeyedString :: IntKeyedString ( int nKeyNew , const char * cszNew )
  : nKey ( nKeyNew ) , istring ( cszNew )
{

} /* IntKeyedString :: IntKeyedString ( int nKeyNew , const char * cszNew ) */



IntKeyedString :: ~IntKeyedString ()
{
  cout  << "Destroying object with key value of " << nKey << " and string value of " << istring << endl ;

} /* IntKeyedString :: ~IntKeyedString () */



int CountedKeyedString :: nObjCount = 1 ;



/**************************************   END OF FILE KEYITEMTEST.CPP   ***************************************************/
